
//Disaster Dash and ToastKart both have Permission from DarkyBenji
//Spindash by Darkybenji
//Please Note that this is inspired from Spindash in srb2kart v2, but do NOT work like Spindash v2!
//I should release it in MB anytime now.

local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_squishedtimer = k_squishedtimer
local k_justbumped = k_justbumped
local k_drift = k_drift
local k_driftcharge = k_driftcharge
local k_driftboost = k_driftboost
local k_offroad = k_offroad
local k_invincibilitytimer = k_invincibilitytimer
local k_hyudorotimer = k_hyudorotimer
local k_startboost = k_startboost

local starttime = 6*TICRATE+(3*TICRATE/4)+40

freeslot("sfx_ddrift") //tfw the original don't work

rawset(_G, "spindash", CV_RegisterVar({
    name = "sd_active",
    defaultvalue = "On",
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff
}))

local spindash_reminder = CV_RegisterVar({
	name = "sd_reminder",
	defaultvalue = "On",
	flags = CV_SHOWMODIF,
	possiblevalue = CV_OnOff
})

local spindash_iframes = CV_RegisterVar({
    name = "sd_iframes",
    defaultvalue = "DoNothing",
    flags = CV_NETVAR|CV_SHOWMODIF,
    possiblevalue = {DoNothing = 0, BlockCharge = 1, KillIt = 2}
}) 

local spindash_fastercharge = CV_RegisterVar({
    name = "sd_fastercharge",
    defaultvalue = "On",
    flags = CV_NETVAR|CV_SHOWMODIF,
    possiblevalue = CV_OnOff
}) 

local spindash_offroad = CV_RegisterVar({
    name = "sd_offroad",
    defaultvalue = "On",
    flags = CV_NETVAR|CV_SHOWMODIF,
    possiblevalue = CV_OnOff
}) 

local spindash_debug = CV_RegisterVar({
	name = "sd_debug",
	defaultvalue = "Off",
	flags = CV_NOSHOWHELP,
	possiblevalue = CV_OnOff
})

--------------------------------------------------------------
//The Setup function
--------------------------------------------------------------
local function SD_SetupSpinDash(p)
	p.spindash = {
		active = false,
		charging = 0,
		input = 0,
		hurt = 0,
		boost = 0,
		offroad = 0,
		reminded = 0
	}
end

rawset(_G, "GetSpindashSparkValue", function(p)
	return (26*4 + (p.kartspeed*2) + p.kartweight)*8
end)

--------------------------------------------------------------
//Checking function
--------------------------------------------------------------
local function SD_CheckPlayerSpeed(p)
	return FixedDiv(p.speed, mapobjectscale)/FRACUNIT
end

local function SD_IsPlayerOffroad(p)
	return p.kartstuff[k_offroad] >= FRACUNIT
	and p.kartstuff[k_invincibilitytimer] == 0
	and p.kartstuff[k_hyudorotimer] == 0
end

local function SD_IsFlashing(p)
	return p.powers[pw_flashing]
	and p.kartstuff[k_hyudorotimer] == 0
end

local function SD_CanItSpindash(p)
	return P_IsObjectOnGround(p.mo)
	and p.playerstate == PST_LIVE 
	and p.kartstuff[k_drift] == 0
	and not p.kartstuff[k_sneakertimer]
	and not p.kartstuff[k_justbumped]
	and not p.kartstuff[k_spinouttimer] 
	and not p.kartstuff[k_squishedtimer]
	and not p.kartstuff[k_driftcharge] 
	and not p.kartstuff[k_driftboost]
	and not p.kartstuff[k_startboost]
	and not p.spindash.hurt 
	and not p.exiting
	and p.cmd.buttons & BT_BRAKE and p.cmd.buttons & BT_ACCELERATE
end

local function SD_IsSpindashRuined(p)
	return p.kartstuff[k_sneakertimer]
	or p.kartstuff[k_justbumped]
	or p.kartstuff[k_spinouttimer]
	or p.kartstuff[k_squishedtimer]
	or p.pflags == PF_SKIDDOWN
	or p.playerstate == PST_DEAD
end

local function SD_IsSpindashDamaged(p)
	return p.kartstuff[k_spinouttimer]
	or p.kartstuff[k_squishedtimer]
	or p.trickstun --Acro
end

--------------------------------------------------------------
//Visual Effect
--------------------------------------------------------------
local function SD_SpawnDriftSparks(p)
	if (leveltime % 2 == 1) then return end
	local travelangle = p.mo.angle-(ANGLE_45/5)*p.kartstuff[k_drift]

	for i = 0, 1 do
		local newX = p.mo.x + P_ReturnThrustX(p.mo, travelangle + ((i == 0) and -1 or 1)*ANGLE_135, FixedMul(32*FRACUNIT, p.mo.scale))
		local newY = p.mo.y + P_ReturnThrustY(p.mo, travelangle + ((i == 0) and -1 or 1)*ANGLE_135, FixedMul(32*FRACUNIT, p.mo.scale))
		local Spark = P_SpawnMobj(newX, newY, p.mo.z, MT_DRIFTSPARK)
		Spark.target = p.mo
		Spark.angle = travelangle-(ANGLE_45/5)*p.kartstuff[k_drift]
		Spark.destscale = p.mo.scale/2
		Spark.momx = p.mo.momx/2
		Spark.momy = p.mo.momy/2
		
		if p.spindash.charging >= GetSpindashSparkValue(p)*4 then
			Spark.color = (1 + (leveltime % (MAXSKINCOLORS-1)))
			P_SetScale(Spark, 3*p.mo.scale/2)
		elseif p.spindash.charging >= GetSpindashSparkValue(p)*2 then
			if p.spindash.charging <= (GetSpindashSparkValue(p)*2)+(24*3) then
				Spark.color = SKINCOLOR_RASPBERRY
			else
				Spark.color = SKINCOLOR_KETCHUP
			end
			P_SetScale(Spark, 5*p.mo.scale/4)
		else
			Spark.color = SKINCOLOR_SAPPHIRE
			P_SetScale(Spark, p.mo.scale)
		end
		
		if (leveltime % 4 == 0) then S_StartSoundAtVolume(p.mo, sfx_cdfm17, 128) end
		K_MatchGenericExtraFlags(Spark, p.mo)
	end
end

local function SD_DriftDustHandling(p)
	if (leveltime % 2 != 0) or p.spindash.charging then return end

	local DustH = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_DRIFTDUST)
	local speedrange = 2
	DustH.momx = FixedMul(p.mo.momx + (P_RandomRange(-speedrange, speedrange)<<FRACBITS), 3*(p.mo.scale)/4)
	DustH.momy = FixedMul(p.mo.momy + (P_RandomRange(-speedrange, speedrange)<<FRACBITS), 3*(p.mo.scale)/4)
	DustH.momz = P_MobjFlip(p.mo)*(P_RandomRange(1, 4)*(p.mo.scale))
	P_SetScale(DustH, p.mo.scale/2)
	DustH.destscale = p.mo.scale*3
	DustH.scalespeed = p.mo.scale/12
	
	if (leveltime % 6 == 0) then S_StartSound(p.mo, sfx_screec) end
	K_MatchGenericExtraFlags(DustH, p.mo)
end

local function SD_SpawnDustRelease(p, time)
	local travelangle = p.mo.angle
	if time == nil then time = 1 end
	
	if (leveltime%time == 0) then
		for i = 0, 1 do 
			local newX = p.mo.x + P_ReturnThrustX(p.mo, travelangle + ((i == 0) and -1 or 1)*ANGLE_90, FixedMul(48*FRACUNIT, p.mo.scale))
			local newY = p.mo.y + P_ReturnThrustY(p.mo, travelangle + ((i == 0) and -1 or 1)*ANGLE_90, FixedMul(48*FRACUNIT, p.mo.scale))
			local DDust = P_SpawnMobj(newX, newY, p.mo.z, MT_FASTDUST)

			DDust.target = p.mo
			DDust.angle = travelangle - ((i == 0) and -1 or 1)*ANGLE_45
			DDust.destscale = p.mo.scale
			
			if p.spindash.input then 
				P_SetScale(DDust, p.mo.scale*2)
			else
				P_SetScale(DDust, p.mo.scale)
			end

			DDust.momx = 3*p.mo.momx/5
			DDust.momy = 3*p.mo.momy/5
		end
	end
end

local function SD_StateAnimation(p)
	if p.mo.state != S_INVISIBLE then --for Mk64 or salty hop, or whatever it can be
		if (p.cmd.driftturn < 0 and not (p.mo.state >= S_KART_WALK1_R and p.mo.state <= S_KART_WALK2_R))
			if (leveltime%2 == 1) then p.mo.state = S_KART_WALK1_R else p.mo.state = S_KART_WALK2_R end 
		elseif (p.cmd.driftturn > 0 and not (p.mo.state >= S_KART_WALK1_L and p.mo.state <= S_KART_WALK2_L))
			if (leveltime%2 == 1) then p.mo.state = S_KART_WALK1_L else p.mo.state = S_KART_WALK2_L end
		elseif (p.cmd.driftturn == 0 and not (p.mo.state >= S_KART_WALK1 and p.mo.state <= S_KART_WALK2))
			if (leveltime%2 == 1) then p.mo.state = S_KART_WALK1 else p.mo.state = S_KART_WALK2 end
		end
	end
	if not S_SoundPlaying(p.mo, sfx_ddrift) then S_StartSound(p.mo, sfx_ddrift) end
end

--------------------------------------------------------------------------------
//ThinkFrame
--------------------------------------------------------------------------------
local function SD_GiveBoost(p)
	if p.spindash.charging >= GetSpindashSparkValue(p)*4 then --rainbow sparks
		p.spindash.boost = 125
	elseif p.spindash.charging >= GetSpindashSparkValue(p)*2 then --orange sparks
		p.spindash.boost = 50
	else --blue sparks
		p.spindash.boost = 20
	end

	if SD_IsPlayerOffroad(p) then --Allow you to escape Offroad if needed
		local OffroadLvl = p.kartstuff[k_offroad]/FRACUNIT --1 to 3
		p.spindash.boost = $/OffroadLvl
		p.spindash.offroad = p.spindash.boost
	end
	
	local ThrustSpinDash = K_GetKartSpeed(p, false)/100*p.spindash.boost
	P_InstaThrust(p.mo, p.mo.angle, ThrustSpinDash)
end

local function SD_ShutUp(p)
	S_StopSoundByID(p.mo, sfx_ddrift) 
	S_StopSoundByID(p.mo, sfx_s260) 
	S_StopSoundByID(p.mo, sfx_s23e) 
end

local function SD_Charging(p, additive)
	if p.spindash.charging < GetSpindashSparkValue(p) then 
		p.spindash.charging = min($ + additive, GetSpindashSparkValue(p))
		if p.spindash.charging == GetSpindashSparkValue(p) then S_StartSoundAtVolume(p.mo, sfx_s3ka2, 192) end
	elseif p.spindash.charging < GetSpindashSparkValue(p)*2 then 
		p.spindash.charging = min($ + additive, GetSpindashSparkValue(p)*2)
		if p.spindash.charging == GetSpindashSparkValue(p)*2 then S_StartSoundAtVolume(p.mo, sfx_s3ka2, 192) end
	elseif p.spindash.charging < GetSpindashSparkValue(p)*4 then 
		p.spindash.charging = min($ + additive, GetSpindashSparkValue(p)*4)
		if p.spindash.charging == GetSpindashSparkValue(p)*4 then S_StartSoundAtVolume(p.mo, sfx_s3ka2, 192) end
	elseif p.spindash.charging < GetSpindashSparkValue(p)*5 then 
		p.spindash.charging = min($ + additive, GetSpindashSparkValue(p)*5)
	end
end

local function SD_Standing(p)
	SD_StateAnimation(p)
	SD_DriftDustHandling(p)
	p.powers[pw_nocontrol] = 2
	if p.mo.momx > 0 then p.mo.momx = max($-($/32), 0) else p.mo.momx = min($-($/32), 0) end
	if p.mo.momy > 0 then p.mo.momy = max($-($/32), 0) else p.mo.momy = min($-($/32), 0) end
end

local function SD_Think(p)
	if SD_CheckPlayerSpeed(p) > 20 then return end
	if ((spindash_iframes.value == 1 and SD_IsFlashing(p)) or (G_BattleGametype()))
	or (not spindash_offroad.value and SD_IsPlayerOffroad(p))
	or p.exiting then return end
	
	SD_Charging(p, 24)	
	if p.spindash.charging == 24 then 
		S_StartSoundAtVolume(p.mo, sfx_s260, 128)
	end
		
	if spindash_iframes.value == 2 and SD_IsFlashing(p) then --fuck you
		p.powers[pw_flashing] = 0 
		if kmp and kmp_extendflashtics.value then p.mo.K_fakeflashing = 0 end --lol KartMP
	end
		
	if SD_IsPlayerOffroad(p) then
		K_SpawnWipeoutTrail(p.mo) 
	else
		SD_SpawnDustRelease(p, 6) 
		if spindash_fastercharge.value then
			if (p.cmd.buttons & BT_DRIFT) then --Hold that DRIFT button!
				p.spindash.input = min($+1, 24)
				if p.spindash.input == 1
					S_StartSoundAtVolume(p.mo, sfx_s23e, 128)
				end
			else
				p.spindash.input = 0
			end
			if spindash_reminder.value and p.spindash.reminded == 1 then 
				chatprintf(p, "\x84*You can also hold the\x82 DRIFT\x84 button to charge it faster! But carefull to\x85 not overcharge it...", true)
				p.spindash.reminded = $+1
			end
		end
				
		if p.spindash.input then
			SD_Charging(p, p.spindash.input) --Haha i'm a genius!
			if leveltime%4 == 1 then p.mo.colorized = true end
			if SD_IsFlashing(p) then --Another One
				p.powers[pw_flashing] = max($ - p.spindash.input, 0)
				if kmp and kmp_extendflashtics.value and p.mo.K_fakeflashing then p.mo.K_fakeflashing = max($ - p.spindash.input, 0) end --lol KartMP
				if p.spindash.input == 24 then
					p.powers[pw_flashing] = 0
					if kmp and kmp_extendflashtics.value and p.mo.K_fakeflashing then p.mo.K_fakeflashing = 0 end --lol KartMP	
				end
			end
		end	
	end
	
	if p.spindash.charging >= GetSpindashSparkValue(p) then
		SD_SpawnDriftSparks(p)
	end
								
	if not p.kartstuff[k_invincibilitytimer] then
		if p.spindash.charging >= GetSpindashSparkValue(p)*9/2 --Oh no
			S_StartSound(p.mo, sfx_s3k83)
			p.powers[pw_nocontrol] = 40
			p.pflags = PF_SKIDDOWN
		end
	end
end

local function SD_Release(p)
	if p.exiting or not p.spindash.charging then return end
	
	if p.spindash.charging >= GetSpindashSparkValue(p) then --You've done it! Off you go!
		SD_GiveBoost(p)
		SD_SpawnDustRelease(p)
		S_StartSound(p.mo, sfx_s23c)
		if P_RandomChance(FRACUNIT/4) then K_PlayAttackTaunt(p.mo) end
		p.spindash.charging = 0
	end
	p.spindash.charging = max($ - 12, 0) --Man
	p.spindash.input = 0
end

local function SD_Stop(p)
	if not p.spindash.charging then return end

	if not p.kartstuff[k_sneakertimer] then S_StartSound(p.mo, sfx_cdfm00) end
	p.spindash.hurt = TICRATE*3/2
	p.spindash.charging = 0
end

local function SD_ThinkBoost(p)
	if p.exiting or not p.spindash.boost then return end
	
	if P_IsObjectOnGround(p.mo) then
		p.kartstuff[k_driftboost] = max($, p.spindash.boost)
		p.kartstuff[k_accelboost] = max($, 6*FRACUNIT)
	end
	if p.spindash.offroad then
		p.kartstuff[k_offroad] = 0
	end
	if SD_IsSpindashDamaged(p) then
		p.spindash.boost = 0
		p.spindash.offroad = 0
	end
end

local function SD_Timer(p)
	if p.exiting then return end
	
	p.spindash.hurt = max($-1, 0)
	p.spindash.boost = max($-1, 0)
	p.spindash.offroad = max($-1, 0)
end

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

addHook("MapLoad", do 		
	for p in players.iterate do	
		p.spindash = nil
	end
end)

addHook("ThinkFrame", do
	if not spindash.value then return end
	for p in players.iterate do
        if not (p.mo and p.mo.valid) continue end 
		if p.spindash == nil then SD_SetupSpinDash(p) end
		if leveltime <= starttime or p.spectator continue end

		if SD_CanItSpindash(p) then
			SD_Standing(p)
			SD_Think(p)
			p.spindash.active = true
		else
			SD_Release(p)
			SD_ShutUp(p)
			p.spindash.active = false
		end
		
		if SD_IsSpindashRuined(p) then
			SD_Stop(p)
		end
		
		SD_ThinkBoost(p)
		SD_Timer(p)

		--Reminder
		if SD_CheckPlayerSpeed(p) < 10 and P_IsObjectOnGround(p.mo) and not SD_IsSpindashRuined(p) and not p.exiting
		and spindash_reminder.value and p.spindash.reminded == 0 then
			chatprintf(p, "\x84*You can\x88 Spindash\x84 by Holding both\x82 ACCEL\x84 and\x82 BRAKE\x84 to charge it, and release it\x88 when it's Ready!", true)
			p.spindash.reminded = $+1
		end
	end
end)

hud.add(function(v, p, c) 
	if p.spindash == nil or p.exiting or not spindash_debug.value then return end
	v.drawString(12,85, "SpinDashBoost: "..p.spindash.boost.."",V_ALLOWLOWERCASE|V_SNAPTOLEFT,"thin")
	v.drawString(12,95, "DriftBoost: "..p.kartstuff[k_driftboost].."",V_ALLOWLOWERCASE|V_SNAPTOLEFT,"thin")
	v.drawString(12,105, "Offroad Immunity: "..p.spindash.offroad.."",V_ALLOWLOWERCASE|V_SNAPTOLEFT,"thin")
	v.drawString(12,125, "Charging: "..p.spindash.charging.."",V_ALLOWLOWERCASE|V_SNAPTOLEFT,"thin")
	v.drawString(12,135, "SpindashSparkValue: "..GetSpindashSparkValue(p).."",V_ALLOWLOWERCASE|V_SNAPTOLEFT,"thin")
end)

--------------------------------------------------------------------------------
//Hostmod
--------------------------------------------------------------------------------
local sd_didyouknow = {
	{msg = "Bumping someone that is doing Spindash, can cancel it. You can ruin someone's day just like that"},
	{msg = "Spindash is not only for recovery after damage, it can also be used for leaving offroad or slopes."},
	{msg = "You cannot charge Spindash faster if you're on Offroad."}
}

local HMSpindash_load = false
local function HMSpindash()
	if HOSTMOD and not HMSpindash_load then
		HM_Scoreboard_AddMod({disp = "SpinDash", var = "sd_active"})
		for i = 1, #sd_didyouknow do
			HM_Scoreboard_AddTip(sd_didyouknow[i])
		end
		HMSpindash_load = true
	end
end

addHook("MapLoad", HMSpindash)
addHook("NetVars", HMSpindash) -- Joiners don't run MapLoad