//saltyhop command by SMS Alfredo
COM_AddCommand("saltyhop", function(player, arg)
	if not (player.mo and player.mo.valid) then CONS_Printf(player, "This can only be used in a level!") return end
	if arg
		if arg == "0" or arg == "off" or arg == "false"
			player.saltyhop = false
			if io and player == consoleplayer
				local file = io.open("saltyhop.cfg", "w+")
				file:write(0)
				file:close()
			end
		elseif arg == "1" or arg == "on" or arg == "default" or arg == "true"
			player.saltyhop = true
			if io and player == consoleplayer
				local file = io.open("saltyhop.cfg", "w+")
				file:write(1)
				file:close()
			end
		else
			CONS_Printf(player, "saltyhop [on/off] - Toggles whether or not you jump.")
			CONS_Printf(player, "Note that this jump is 100% visual and does not affect gameplay in any way. No jumping over walls or offroad here.")
		end
	else
		CONS_Printf(player, "saltyhop [on/off] - Toggles whether or not you jump.")
		CONS_Printf(player, "Note that this jump is 100% visual and does not affect gameplay in any way. No jumping over walls or offroad here.")
	end
end, 0)

//I/O junk for the command above
addHook("PlayerSpawn", function(player)
	if io and player.saltyhop == nil and player == consoleplayer
		local file = io.open("saltyhop.cfg", "r")
		if file
			local num = file:read("*n")
			if num != nil and num == 0 or num == 1
				COM_BufInsertText(consoleplayer, "saltyhop "..num)
			else
				COM_BufInsertText(consoleplayer, "saltyhop 1")
			end
			file:close()
		end
	end
end)

//"Followitem" used for the angles and spiltscreen
freeslot("MT_SALTY_CLONE")
mobjinfo[MT_SALTY_CLONE] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = mobjinfo[MT_PLAYER].radius,
	height = mobjinfo[MT_PLAYER].height,
	dispoffset = 0,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}

addHook("MobjThinker", function(mobj)
	if not (mobj and mobj.valid and mobj.reactiontime) return end
	local mo = mobj.tracer
	
	if not (mo and mo.valid and mo.player
	and mo.skin != "mk64mario" and mo.skin != "mk64luigi"
	and mo.skin != "mk64yoshi" and mo.skin != "mk64peach"
	and mo.skin != "mk64toad" and mo.skin != "mk64wario"
	and mo.skin != "mk64dk" and mo.skin != "mk64bowser")
		P_KillMobj(mobj)
		return
	end
	
	local player = mo.player
	
	P_TeleportMove(mobj, mo.x, mo.y, mo.z)
	
	if not player.saltyhopjump
		mobj.flags2 = $|MF2_DONTDRAW
		return
	end
	
	//Set all the relative variables
	mobj.skin = mo.skin
	mobj.state = mo.state
	mobj.sprite = mo.sprite
	mobj.frame = mo.frame
	mobj.angle = player.frameangle
	mobj.color = mo.color
	mobj.colorized = mo.colorized
	mobj.scale = mo.scale
	mobj.radius = mo.radius
	mobj.height = mo.height
	mobj.flags2 = mo.flags2&(MF2_OBJECTFLIP|MF2_SHADOW|MF2_DONTDRAW)
	mobj.eflags = mo.eflags&(MFE_VERTICALFLIP|MFE_DRAWONLYFORP1|MFE_DRAWONLYFORP2|MFE_DRAWONLYFORP3|MFE_DRAWONLYFORP4)
	
	return true
end, MT_SALTY_CLONE)

//It feels wrong using ThinkFrame instead of PlayerThink now
addHook("ThinkFrame", do
for player in players.iterate
	if player.mo and player.mo.valid
	and player.mo.skin != "mk64mario" and player.mo.skin != "mk64luigi"
	and player.mo.skin != "mk64yoshi" and player.mo.skin != "mk64peach"
	and player.mo.skin != "mk64toad" and player.mo.skin != "mk64wario"
	and player.mo.skin != "mk64dk" and player.mo.skin != "mk64bowser"
	
		if not (player.saltyhopclone and player.saltyhopclone.valid)
			player.saltyhopclone = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SALTY_CLONE)
			player.saltyhopclone.skin = player.mo.skin
			player.saltyhopclone.tracer = player.mo
			player.saltyhopclone.reactiontime = i+1
			player.saltyhopclone.flags2 = $|MF2_DONTDRAW
		end
		
		//Jump Detection
		if not player.kartstuff[k_jmp]
			player.saltyhopdrifttapready = true
			player.saltyhopdrifttapping = false
		elseif player.saltyhopdrifttapready then
			player.saltyhopdrifttapping = true
			player.saltyhopdrifttapready = false
		else
			player.saltyhopdrifttapping = false
		end
		
		//Landing sound
		if P_IsObjectOnGround(player.mo) or player.saltyhopairtime == nil
		or player.kartstuff[k_respawn]
			if player.saltyhopairtime and player.saltyhopairtime > 7
			and player.mo.eflags&MFE_JUSTHITFLOOR and player.mo.health
			and not (player.mo.eflags&MFE_JUSTSTEPPEDDOWN)
				local z = player.mo.z
				if player.mo.eflags&MFE_VERTICALFLIP
					z = $+(player.mo.height/2)
				end
				if player.saltyhopairtime > TICRATE*2/3 and not player.kartstuff[k_spinouttimer]
					if player.saltyhopairtime > TICRATE*3
						if player == displayplayers[0] and not splitscreen
							P_StartQuake(48*FRACUNIT, 2)
						end
						S_StartSound(player.mo, sfx_s3k5f)
					elseif player == displayplayers[0] and not splitscreen
							P_StartQuake(32*FRACUNIT, 2)
					end
					S_StartSound(player.mo, sfx_s3k96)
				else
					if player == displayplayers[0] and not splitscreen
						P_StartQuake(16*FRACUNIT, 2)
					end
					S_StartSound(player.mo, sfx_s268)
				end
				P_SpawnParaloop(player.mo.x, player.mo.y, z,
				player.mo.radius*4, 8, MT_DRIFTDUST, ANGLE_90, nil, true)
			end
			player.saltyhopairtime = 0
		else
			player.saltyhopairtime = $+1
		end
		
		//Fake jumping
		//It's entirely visual and you're technically still on the ground
		if player.saltyhopzoffset == nil
			player.saltyhopjump = false
			player.saltyhopzoffset = 0
			player.saltyhopmomz = 0
		elseif player.saltyhopjump
			if player.mo.eflags&MFE_JUSTHITFLOOR
				player.saltyhopzoffset = 0
			elseif P_IsObjectOnGround(player.mo)
				player.saltyhopzoffset = $+player.saltyhopmomz
				player.saltyhopmomz = $-(mapobjectscale*3/2)
			else
				player.saltyhopzoffset = $*49/50
				player.saltyhopmomz = 0
			end
			if player.saltyhopzoffset <= 0
				if not (player.mo.eflags&MFE_JUSTHITFLOOR)
				and P_IsObjectOnGround(player.mo)
					S_StartSound(player.mo, sfx_s268)
				end
				player.saltyhopjump = false
				player.saltyhopzoffset = 0
				player.saltyhopmomz = 0
			end
			if player.saltyhopclone != nil
				player.saltyhopclone.z = $+player.saltyhopzoffset*P_MobjFlip(player.mo)
				if player.ksc_colors
				and player.mo.ksc_overlay and player.mo.ksc_overlay.valid
					player.mo.ksc_overlay.z = player.saltyhopclone.z
				end
			end
			if player.saltyhopzoffset != 0
				player.mo.state = S_INVISIBLE
			end
			if S_SoundPlaying(player.mo, sfx_screec)
				S_StopSoundByID(player.mo, sfx_screec)
			end
			if S_SoundPlaying(player.mo, sfx_drift)
				S_StopSoundByID(player.mo, sfx_drift)
			end
		elseif player.saltyhopdrifttapping and P_IsObjectOnGround(player.mo)
		and leveltime >= 6*TICRATE + (3*TICRATE/4)
		and not player.kartstuff[k_spinouttimer]
		and not player.kartstuff[k_squishedtimer]
		and not player.spindashactive
		and player.saltyhop //Yay for customization
			player.saltyhopjump = true
			player.saltyhopzoffset = 0
			player.saltyhopmomz = player.mo.scale*6
			S_StartSound(player.mo, sfx_s25a)
		end
	end
end
end)